//////////////////
//  num_set.c   //
//  2008/02/19  //
//////////////////

#include "global.h"

#define ST_SET_IDOL	0
#define ST_SET_READY	1
#define ST_SET_UPDOWN	2
#define ST_SET_WRITE	3

#define min 		10
#define max 		40
#define set_init	25
#define e2addr	0

char set_point;
static char state;
rom const char *msg1 = {"ò ƭخ"};

void lcd_num2d(char n)
{
	char n1,n2,nflg;
	if(n < 0) {
		nflg = 1;
		n = -n;
	}
	else nflg = 0;
	
	n1 = n/10;
	n2 = n%10;
	if(nflg) lcd_data('-');
	else lcd_data(' ');
	if(n1) lcd_data(n1 + 0x30);
	else lcd_data(' ');
	lcd_data(n2 + 0x30);
}

void num_init(void)
{
	set_point = read_e2rom(e2addr);
	if(set_point < min || set_point > max){
		set_point = set_init;
		write_e2rom(e2addr, set_init);
		delay_ms(7);
	}
	state = ST_SET_IDOL;
}

void num_set(void)
{
	static char buff;
	
	switch(state){
		case ST_SET_IDOL:
			if(MODE_L){
				lcd_cmd(0x80);
				buff = set_point;
				lcd_str_rom(msg1);
				lcd_cmd(0xc0);
				lcd_num2d(buff);
				state = ST_SET_READY;
				return;
			}
			break;
		case ST_SET_READY:
			if(!MODE){
				state = ST_SET_UPDOWN;
				timer_start(TIMER_SCAN, 10);
				return;
			}
			break;
		case ST_SET_UPDOWN:
			if(!timer_check(TIMER_SCAN))return;
			if(DOWN && (!DOWN_L)){
				if(buff > min) buff--;
				lcd_cmd(0xc0);
				lcd_num2d(buff);
				timer_start(TIMER_SCAN, 800);
				timer_cancel(TIMER_SET_CANCEL);
				return;
			}
			if(DOWN_L){
				if(buff > min) buff--;
				lcd_cmd(0xc0);
				lcd_num2d(buff);
				timer_start(TIMER_SCAN, 80);
				return;
			}		
			if(UP && (!UP_L)){
				if(buff < max) buff++;
				lcd_cmd(0xc0);
				lcd_num2d(buff);
				timer_start(TIMER_SCAN, 800);
				timer_cancel(TIMER_SET_CANCEL);
				return;
			}
			if(UP_L){
				if(buff < max) buff++;
				lcd_cmd(0xc0);
				lcd_num2d(buff);
				timer_start(TIMER_SCAN, 80);
				return;
			}
			if(ENT_L){
				set_point = buff;
				write_e2rom(e2addr, set_point);
				timer_start(TIMER_E2WRITE, 7);
				lcd_clear();
				timer_cancel(TIMER_SCAN);
				timer_cancel(TIMER_SET_CANCEL);
				state = ST_SET_WRITE;
				return;
			}
			if(MODE_P){
				MODE_P = 0;
				lcd_clear();
				timer_cancel(TIMER_SCAN);
				timer_cancel(TIMER_SET_CANCEL);
				state = ST_SET_IDOL;
				return;
			}
			if(!UP && !DOWN){
				timer_start(TIMER_SET_CANCEL, 60000);
			}
			if(timer_check(TIMER_SET_CANCEL)){
				lcd_clear();
				timer_cancel(TIMER_SCAN);
				state = ST_SET_IDOL;
				return;
			}
			timer_start(TIMER_SCAN, 10);
			break;
		case ST_SET_WRITE:
			if(!timer_check(TIMER_E2WRITE))return;
			lock_e2rom();
			state = ST_SET_IDOL;
			break;
	}
}
